---
title: CanvasRenderingContext2D.ellipse()
slug: Web/API/CanvasRenderingContext2D/ellipse
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.ellipse()</code></strong> method of the Canvas 2D API adds an elliptical arc to the current sub-path.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>ctx</em>.ellipse(<em>x</em>, <em>y</em>, <em>radiusX</em>, <em>radiusY</em>, <em>rotation</em>, <em>startAngle</em>, <em>endAngle</em> [, <em>anticlockwise</em>]);
</pre>

<p>The <code>ellipse()</code> method creates an elliptical arc centered at <code>(x, y)</code> with the radii <code>radiusX</code> and <code>radiusY</code>. The path starts at <code>startAngle</code> and ends at <code>endAngle</code>, and travels in the direction given by <code>anticlockwise</code> (defaulting to clockwise).</p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>x</code></dt>
 <dd>The x-axis (horizontal) coordinate of the ellipse's center.</dd>
 <dt><code>y</code></dt>
 <dd>The y-axis (vertical) coordinate of the ellipse's center.</dd>
 <dt><code>radiusX</code></dt>
 <dd>The ellipse's major-axis radius. Must be non-negative.</dd>
 <dt><code>radiusY</code></dt>
 <dd>The ellipse's minor-axis radius. Must be non-negative.</dd>
 <dt><code>rotation</code></dt>
 <dd>The rotation of the ellipse, expressed in radians.</dd>
 <dt><code>startAngle</code></dt>
 <dd>The angle at which the ellipse starts, measured clockwise from the positive x-axis and expressed in radians.</dd>
 <dt><code>endAngle</code></dt>
 <dd>The angle at which the ellipse ends, measured clockwise from the positive x-axis and expressed in radians.</dd>
 <dt><code>anticlockwise</code> {{optional_inline}}</dt>
 <dd>An optional {{jsxref("Boolean")}} which, if <code>true</code>, draws the ellipse anticlockwise (counter-clockwise). The default value is <code>false</code> (clockwise).</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Drawing_a_full_ellipse">Drawing a full ellipse</h3>

<p>This example draws an ellipse at an angle of π/4 radians (45<strong>°</strong>). To make a full ellipse, the arc begins at an angle of 0 radians (0<strong>°</strong>), and ends at an angle of 2π radians (360<strong>°</strong>).</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas" width="200" height="200"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[6]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// Draw the ellipse
ctx.beginPath();
ctx.ellipse(100, 100, 50, 75, Math.PI / 4, 0, 2 * Math.PI);
ctx.stroke();

// Draw the ellipse's line of reflection
ctx.beginPath();
ctx.setLineDash([5, 5]);
ctx.moveTo(0, 200);
ctx.lineTo(200, 0);
ctx.stroke();
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Drawing_a_full_ellipse', 700, 250) }}</p>

<h3 id="Various_elliptical_arcs">Various elliptical arcs</h3>

<p>This example creates three elliptical paths with varying properties.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<pre class="brush: js; highlight:[6,11,16]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

ctx.fillStyle = 'red';
ctx.beginPath();
ctx.ellipse(60, 75, 50, 30, Math.PI * .25, 0, Math.PI * 1.5);
ctx.fill();

ctx.fillStyle = 'blue';
ctx.beginPath();
ctx.ellipse(150, 75, 50, 30, Math.PI * .25, 0, Math.PI);
ctx.fill();

ctx.fillStyle = 'green';
ctx.beginPath();
ctx.ellipse(240, 75, 50, 30, Math.PI * .25, 0, Math.PI, true);
ctx.fill();
</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Various_elliptical_arcs', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-ellipse", "CanvasRenderingContext2D.ellipse")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.ellipse")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>Use {{domxref("CanvasRenderingContext2D.arc()")}} to draw a circular arc</li>
</ul>
